var EndUser;
(function (EndUser) {
    var OSName;
    (function (OSName) {
        OSName[OSName["Unknown"] = "Unknown"] = "Unknown";
        OSName[OSName["Windows"] = "Windows"] = "Windows";
        OSName[OSName["Linux"] = "Linux"] = "Linux";
        OSName[OSName["Unix"] = "Unix"] = "Unix";
        OSName[OSName["Mac"] = "Mac OS X"] = "Mac";
    })(OSName = EndUser.OSName || (EndUser.OSName = {}));
    ;
    var BrowserName;
    (function (BrowserName) {
        BrowserName[BrowserName["Unknown"] = "Unknown"] = "Unknown";
        BrowserName[BrowserName["IE"] = "IE"] = "IE";
        BrowserName[BrowserName["Opera"] = "Opera"] = "Opera";
        BrowserName[BrowserName["Chrome"] = "Chrome"] = "Chrome";
        BrowserName[BrowserName["Firefox"] = "Firefox"] = "Firefox";
        BrowserName[BrowserName["Safari"] = "Safari"] = "Safari";
        BrowserName[BrowserName["Edge"] = "Edge"] = "Edge";
    })(BrowserName = EndUser.BrowserName || (EndUser.BrowserName = {}));
    ;
    var BrowserArch;
    (function (BrowserArch) {
        BrowserArch[BrowserArch["Unknown"] = "Unknown"] = "Unknown";
        BrowserArch[BrowserArch["x86"] = "x86"] = "x86";
        BrowserArch[BrowserArch["x64"] = "x64"] = "x64";
    })(BrowserArch = EndUser.BrowserArch || (EndUser.BrowserArch = {}));
    ;
    ;
    var Browser = (function () {
        function Browser() {
        }
        Browser._getInfo = function () {
            var userAgent = navigator.userAgent;
            var appName = navigator.appName;
            var appVersion = navigator.appVersion;
            var platform = navigator.platform || "";
            var tmp;
            var info = {
                name: BrowserName.Unknown,
                version: 0,
                arch: BrowserArch.Unknown,
                osName: OSName.Unknown
            };
            var M = userAgent.match(/(opera|chrome|safari|firefox|msie|trident(?=\/))\/?\s*(\d+)/i) || [];
            if (/msie/i.test(M[1]) || /trident/i.test(M[1])) {
                info.name = BrowserName.IE;
                if (/msie/i.test(M[1])) {
                    info.version = parseInt(M[2]);
                }
                else {
                    tmp = /\brv[ :]+(\d+)/g.exec(userAgent) || [];
                    info.version = parseInt(tmp[1]);
                }
            }
            else if (M[1] === 'Chrome' &&
                ((tmp = userAgent.match(/\b(OPR|Edge)\/(\d+)/)) != null)) {
                info.name = tmp[1].replace('OPR', BrowserName.Opera);
                info.version = parseInt(tmp[2]);
            }
            else {
                M = M[2] ? [M[1], M[2]] : [appName, appVersion, '-?'];
                if ((tmp = userAgent.match(/version\/(\d+)/i)) != null)
                    M.splice(1, 1, tmp[1]);
                info.name = M[0];
                info.version = parseInt(M[1]);
            }
            if (platform.indexOf("Win") != -1) {
                info.osName = OSName.Windows;
                info.arch = (platform.indexOf("Win32") != -1) ?
                    BrowserArch.x86 : BrowserArch.x64;
            }
            else if (platform.indexOf("Mac") != -1) {
                info.osName = OSName.Mac;
                info.arch = (platform.indexOf("MacIntel") != -1) ?
                    BrowserArch.x86 : BrowserArch.x64;
            }
            else if (platform.indexOf("Linux") != -1) {
                info.osName = OSName.Linux;
                info.arch = (platform.indexOf("x86_64") == -1) ?
                    BrowserArch.x86 : BrowserArch.x64;
            }
            else if (platform.indexOf("FreeBSD") != -1) {
                info.osName = OSName.Unix;
                info.arch = (platform.indexOf("x86_64") == -1) ?
                    BrowserArch.x86 : BrowserArch.x64;
            }
            else {
                info.osName = OSName.Unknown;
            }
            return info;
        };
        Browser.info = Browser._getInfo();
        return Browser;
    }());
    EndUser.Browser = Browser;
    ;
})(EndUser || (EndUser = {}));
var WebExtension;
(function (WebExtension) {
    var ELEMENT_ID_CHECK_UPDATE = "menu_item_check_update";
    var ELEMENT_ID_SETTINGS = "menu_item_settings";
    var ELEMENT_ID_HELP = "menu_item_help";
    var ELEMENT_ID_INFORMATION = "menu_item_information";
    var PopupView = (function () {
        function PopupView() {
            this.m_webExtension = null;
        }
        PopupView.prototype._addOnClick = function (id, onClick) {
            document.getElementById(id).addEventListener("click", onClick);
        };
        PopupView.prototype.initialize = function () {
            var pThis = this;
            WebExtension.Translator.translateAllElements(document);
            pThis._addOnClick(ELEMENT_ID_CHECK_UPDATE, function () {
                pThis.checkUpdate();
            });
            pThis._addOnClick(ELEMENT_ID_SETTINGS, function () {
                pThis.setParameters();
            });
            pThis._addOnClick(ELEMENT_ID_HELP, function () {
                pThis.showHelp();
            });
            pThis._addOnClick(ELEMENT_ID_INFORMATION, function () {
                pThis.showInfo();
            });
            WebExtension.BrowserRuntime.getBackgroundPage(function (page) {
                pThis.m_webExtension = page.g_webExtension;
            });
        };
        PopupView.prototype.checkUpdate = function () {
        };
        PopupView.prototype.setParameters = function () {
            WebExtension.BrowserRuntime.tabsCreate({ url: WebExtension.SETTINGS_PAGE_URI });
        };
        PopupView.prototype.showHelp = function () {
            var pThis = this;
            try {
                var msg = WebExtension.BrowserRuntime.i18n(WebExtension.Strings.ALERT_MSG_OPEN_HELP_PAGE) + ' ' +
                    '(' + pThis.m_webExtension.getHelpURL() + ')';
                if (!confirm(msg))
                    return;
                WebExtension.BrowserRuntime.tabsCreate({
                    url: pThis.m_webExtension.getHelpURL()
                });
            }
            catch (e) {
            }
        };
        PopupView.prototype.showInfo = function () {
            var pThis = this;
            var manifest = WebExtension.BrowserRuntime.getManifest();
            var msg = '';
            msg += WebExtension.BrowserRuntime.i18n(WebExtension.Strings.APP_NAME_TITLE) + ': ' +
                manifest.getName() + '\n';
            msg += WebExtension.BrowserRuntime.i18n(WebExtension.Strings.APP_AUTHOR_TITLE) + ': ' +
                WebExtension.BrowserRuntime.i18n(WebExtension.Strings.APP_AUTHOR) + '\n';
            msg += WebExtension.BrowserRuntime.i18n(WebExtension.Strings.APP_VERSION_TITLE) + ': ' +
                manifest.getVersion();
            if (pThis.m_webExtension != null) {
                msg += '\n';
                var nativeAppType = '';
                var nativeAppVersionTitle = '';
                switch (pThis.m_webExtension.getNativeAppType()) {
                    case WebExtension.NativeAppType.NMH:
                        nativeAppType =
                            WebExtension.Strings.NATIVE_APP_STATUS_TITLE_NMH;
                        nativeAppVersionTitle =
                            WebExtension.Strings.NATIVE_APP_VERSION_TITLE_NMH;
                        break;
                    case WebExtension.NativeAppType.NPAPI:
                        nativeAppType =
                            WebExtension.Strings.NATIVE_APP_STATUS_TITLE_NPAPI;
                        nativeAppVersionTitle =
                            WebExtension.Strings.NATIVE_APP_VERSION_TITLE_NPAPI;
                        break;
                }
                msg += WebExtension.BrowserRuntime.i18n(nativeAppType) + ': ' +
                    pThis.m_webExtension.getNativeAppStatusString() + '\n';
                if (pThis.m_webExtension.getNativeAppVersion() != '') {
                    msg += WebExtension.BrowserRuntime.i18n(nativeAppVersionTitle) + ': ' +
                        pThis.m_webExtension.getNativeAppVersion() + '\n';
                }
            }
            alert(msg);
        };
        return PopupView;
    }());
    WebExtension.PopupView = PopupView;
})(WebExtension || (WebExtension = {}));
var WebExtension;
(function (WebExtension) {
    var CLASS_MAIN_PAGE_MENU_TAB = "MainPageMenuTab";
    var CLASS_MAIN_PAGE_MENU_SELECTED_TAB = "MainPageMenuSelectedTab";
    var CLASS_MAIN_PAGE_MENU_PANEL = "MainPageMenuPanel";
    var CLASS_MAIN_PAGE_MENU_PANEL_SELECTED = "MainPageMenuPanelSelected";
    var CLASS_TRUSTED_SITE_DELETE_BUTTON = "TrustedSiteDeleteButton";
    var CLASS_TRUSTED_SITE_URL_TEXT_FIELD = "TrustedSiteURLTextField";
    var ELEMENT_ID_MAIN_PAGE_MENU_WEB_EXTENSION = "MainPageMenuWebExtension";
    var ELEMENT_ID_MAIN_PAGE_MENU_WEB_EXTENSION_PAGE = "MainPageMenuWebExtensionPage";
    var ELEMENT_ID_MAIN_PAGE_MENU_INFO = "MainPageMenuInfo";
    var ELEMENT_ID_MAIN_PAGE_MENU_INFO_PAGE = "MainPageMenuInfoPage";
    var ELEMENT_ID_ADD_TRUSTED_WEB_SITE_URL = "AddTrustedWebSiteURL";
    var ELEMENT_ID_SAVE_TRUSTED_SITES = "SaveTrustedSites";
    var ELEMENT_ID_TRUSTED_WEB_SITES_TABLE = "TrustedWebSitesTable";
    var ELEMENT_ID_TRUSTED_WEB_SITE_URL = "TrustedWebSiteURL";
    var ELEMENT_ID_APP_NAME = "AppName";
    var ELEMENT_ID_APP_AUTHOR = "AppAuthor";
    var ELEMENT_ID_APP_VERSION = "AppVersion";
    var ELEMENT_ID_APP_STATUS = "AppStatus";
    var ELEMENT_ID_APP_DOWNLOAD_URL = "AppDownloadURL";
    var ELEMENT_ID_LIBRARY_VERSION = "LibraryVersion";
    var ELEMENT_ID_HELP_URL = "HelpURL";
    var SettingsView = (function () {
        function SettingsView() {
            this.m_webExtension = null;
        }
        SettingsView.prototype._addOnClick = function (id, onClick) {
            document.getElementById(id).addEventListener("click", onClick);
        };
        SettingsView.prototype._mainMenuItemClicked = function (tab, pageId) {
            var selectedTab = document.getElementsByClassName(CLASS_MAIN_PAGE_MENU_SELECTED_TAB)[0];
            if (selectedTab == tab)
                return false;
            selectedTab.className = CLASS_MAIN_PAGE_MENU_TAB;
            tab.className = CLASS_MAIN_PAGE_MENU_SELECTED_TAB;
            tab.href = 'Tab';
            var selectedPage = document.getElementsByClassName(CLASS_MAIN_PAGE_MENU_PANEL_SELECTED)[0];
            selectedPage.className = CLASS_MAIN_PAGE_MENU_PANEL;
            selectedPage = document.getElementById(pageId);
            selectedPage.className = CLASS_MAIN_PAGE_MENU_PANEL_SELECTED;
            return false;
        };
        SettingsView.prototype._makeTrustedSiteTableRow = function (url) {
            var row = '';
            row += '<div style="float:left;padding-top:3px; width:265px">';
            row += '<input class="' + CLASS_TRUSTED_SITE_URL_TEXT_FIELD +
                '" style="width:100%" type="text" disabled="" value="' + url + '"/>';
            row += '</div>';
            row += '<div id="buttonitem" style="padding-left:10px;width:115px">';
            row += '<a class="' + CLASS_TRUSTED_SITE_DELETE_BUTTON + '" ' +
                'style="cursor:pointer; pointer-events:auto;">';
            row += '<span class="i18n" i18n="button_delete">';
            row += WebExtension.BrowserRuntime.i18n(WebExtension.Strings.BUTTON_DELETE);
            row += '</span>';
            row += '</a>';
            row += '</div>';
            return row;
        };
        SettingsView.prototype._addTrustedSiteToTable = function (url) {
            var table = document.getElementById(ELEMENT_ID_TRUSTED_WEB_SITES_TABLE);
            var row = table.insertRow(table.rows.length);
            var cell = row.insertCell(0);
            cell.innerHTML = this._makeTrustedSiteTableRow(url);
            var button = cell.getElementsByClassName(CLASS_TRUSTED_SITE_DELETE_BUTTON)[0];
            button.addEventListener("click", function () {
                table.deleteRow(row.rowIndex);
            });
        };
        SettingsView.prototype._getTrustedSites = function () {
            var urlsArray = new Array();
            var items = document.getElementsByClassName(CLASS_TRUSTED_SITE_URL_TEXT_FIELD);
            for (var i = 0; i < items.length; i++)
                urlsArray.push(items[i].value);
            return urlsArray;
        };
        SettingsView.prototype.initialize = function () {
            var pThis = this;
            WebExtension.Translator.translateAllElements(document);
            pThis._addOnClick(ELEMENT_ID_MAIN_PAGE_MENU_WEB_EXTENSION, function () {
                pThis._mainMenuItemClicked(this, ELEMENT_ID_MAIN_PAGE_MENU_WEB_EXTENSION_PAGE);
            });
            pThis._addOnClick(ELEMENT_ID_MAIN_PAGE_MENU_INFO, function () {
                pThis._mainMenuItemClicked(this, ELEMENT_ID_MAIN_PAGE_MENU_INFO_PAGE);
            });
            pThis._addOnClick(ELEMENT_ID_ADD_TRUSTED_WEB_SITE_URL, function () {
                pThis.addTrustedSite();
            });
            pThis._addOnClick(ELEMENT_ID_SAVE_TRUSTED_SITES, function () {
                pThis.saveTrustedSites();
            });
            WebExtension.BrowserRuntime.getBackgroundPage(function (page) {
                pThis.m_webExtension = page.g_webExtension;
                var urls = pThis.m_webExtension.getTrustedSites();
                for (var i = 0; i < urls.length; i++)
                    pThis._addTrustedSiteToTable(urls[i]);
                pThis.setInfo();
            });
            pThis.setInfo();
        };
        SettingsView.prototype.addTrustedSite = function () {
            var urlString = document.getElementById(ELEMENT_ID_TRUSTED_WEB_SITE_URL).value;
            var url = EndUser.NetworkUtils.parseURL(urlString);
            if (!url || !url.protocol || !url.hostname) {
                alert(WebExtension.BrowserRuntime.i18n(WebExtension.Strings.ALERT_MSG_INVALID_URL));
                return;
            }
            urlString = url.protocol + "//" + url.hostname;
            var urls = this._getTrustedSites();
            if (urls.indexOf(urlString) >= 0) {
                alert(WebExtension.BrowserRuntime.i18n(WebExtension.Strings.ALERT_MSG_URL_IN_LIST));
                return;
            }
            this._addTrustedSiteToTable(urlString);
        };
        SettingsView.prototype.saveTrustedSites = function () {
            var urls = this._getTrustedSites();
            this.m_webExtension.setTrustedSites(urls, function () {
                alert(WebExtension.BrowserRuntime.i18n(WebExtension.Strings.ALERT_MSG_TRUSTED_SITES_SAVE_SUCCESS));
            }, function () {
                alert(WebExtension.BrowserRuntime.i18n(WebExtension.Strings.ALERT_MSG_TRUSTED_SITES_SAVE_ERROR));
            });
        };
        SettingsView.prototype.setInfo = function () {
            var _setInfoDiv = function (id, title, text) {
                var el = document.getElementById(id);
                el.innerHTML = '<b>' + title + ': ' + '</b>' + text;
            };
            var _makeURLEl = function (url) {
                return '<a href="' + url + '">' +
                    url.substring(url.lastIndexOf('/') + 1) + '</a>';
            };
            var pThis = this;
            var manifest = WebExtension.BrowserRuntime.getManifest();
            _setInfoDiv(ELEMENT_ID_APP_NAME, WebExtension.BrowserRuntime.i18n(WebExtension.Strings.APP_NAME_TITLE), manifest.getName());
            _setInfoDiv(ELEMENT_ID_APP_AUTHOR, WebExtension.BrowserRuntime.i18n(WebExtension.Strings.APP_AUTHOR_TITLE), WebExtension.BrowserRuntime.i18n(WebExtension.Strings.APP_AUTHOR));
            _setInfoDiv(ELEMENT_ID_APP_VERSION, WebExtension.BrowserRuntime.i18n(WebExtension.Strings.APP_VERSION_TITLE), manifest.getVersion());
            if (pThis.m_webExtension != null) {
                var nativeAppType = '';
                var nativeAppVersionTitle = '';
                switch (pThis.m_webExtension.getNativeAppType()) {
                    case WebExtension.NativeAppType.NMH:
                        nativeAppType =
                            WebExtension.Strings.NATIVE_APP_STATUS_TITLE_NMH;
                        nativeAppVersionTitle =
                            WebExtension.Strings.NATIVE_APP_VERSION_TITLE_NMH;
                        break;
                    case WebExtension.NativeAppType.NPAPI:
                        nativeAppType =
                            WebExtension.Strings.NATIVE_APP_STATUS_TITLE_NPAPI;
                        nativeAppVersionTitle =
                            WebExtension.Strings.NATIVE_APP_VERSION_TITLE_NPAPI;
                        break;
                }
                var installs = pThis.m_webExtension.getInstallURLs();
                _setInfoDiv(ELEMENT_ID_APP_STATUS, WebExtension.BrowserRuntime.i18n(nativeAppType), pThis.m_webExtension.getNativeAppStatusString());
                _setInfoDiv(ELEMENT_ID_LIBRARY_VERSION, WebExtension.BrowserRuntime.i18n(nativeAppVersionTitle), pThis.m_webExtension.getNativeAppVersion());
                if (pThis.m_webExtension.getNativeAppStatus() ==
                    WebExtension.WebExtensionStatus.NOT_INSTALLED &&
                    installs != null && installs.length > 0) {
                    var urls = '';
                    for (var i = 0; i < installs.length; i++) {
                        urls += _makeURLEl(installs[i]);
                        urls += (i != 0) ? '<br>' : '';
                    }
                    _setInfoDiv(ELEMENT_ID_APP_DOWNLOAD_URL, WebExtension.BrowserRuntime.i18n(WebExtension.Strings.NATIVE_APP_DOWNLOAD_AND_INSTALL), urls);
                    document.getElementById(ELEMENT_ID_APP_DOWNLOAD_URL).style.display = '';
                }
                else {
                    document.getElementById(ELEMENT_ID_APP_DOWNLOAD_URL).style.display = 'none';
                }
                _setInfoDiv(ELEMENT_ID_HELP_URL, WebExtension.BrowserRuntime.i18n(WebExtension.Strings.LABEL_HELP), _makeURLEl(pThis.m_webExtension.getHelpURL()));
            }
        };
        return SettingsView;
    }());
    WebExtension.SettingsView = SettingsView;
})(WebExtension || (WebExtension = {}));
var EndUser;
(function (EndUser) {
    var Base64Coder = (function () {
        function Base64Coder() {
        }
        Base64Coder.encode = function (arr) {
            var str;
            arr = new Uint8Array(arr);
            str = '';
            for (var i = 0; i < arr.length; i += 3) {
                str += Base64Coder.MAP[arr[i] >> 2];
                str += Base64Coder.MAP[((arr[i] & 3) << 4) | (arr[i + 1] >> 4)];
                str += Base64Coder.MAP[((arr[i + 1] & 15) << 2) | (arr[i + 2] >> 6)];
                str += Base64Coder.MAP[arr[i + 2] & 63];
            }
            if ((arr.length % 3) === 2) {
                str = str.substring(0, str.length - 1) + '=';
            }
            else if (arr.length % 3 === 1) {
                str = str.substring(0, str.length - 2) + '==';
            }
            return str;
        };
        ;
        Base64Coder.decode = function (base64Str) {
            var bytes;
            var bytesLength;
            var i, p;
            var base64StrLength;
            var encoded1, encoded2, encoded3, encoded4;
            var arrayBuffer;
            if (base64Str == "")
                return new Uint8Array(0);
            bytesLength = base64Str.length * 0.75;
            base64StrLength = base64Str.length;
            if (base64Str[base64Str.length - 1] === '=') {
                bytesLength--;
                if (base64Str[base64Str.length - 2] === '=') {
                    bytesLength--;
                }
            }
            arrayBuffer = new ArrayBuffer(bytesLength),
                bytes = new Uint8Array(arrayBuffer);
            p = 0;
            for (i = 0; i < base64StrLength; i += 4) {
                encoded1 = Base64Coder.MAP.indexOf(base64Str[i]);
                encoded2 = Base64Coder.MAP.indexOf(base64Str[i + 1]);
                encoded3 = Base64Coder.MAP.indexOf(base64Str[i + 2]);
                encoded4 = Base64Coder.MAP.indexOf(base64Str[i + 3]);
                bytes[p++] = (encoded1 << 2) | (encoded2 >> 4);
                bytes[p++] = ((encoded2 & 15) << 4) | (encoded3 >> 2);
                bytes[p++] = ((encoded3 & 3) << 6) | (encoded4 & 63);
            }
            return bytes;
        };
        ;
        Base64Coder.MAP = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
        return Base64Coder;
    }());
    EndUser.Base64Coder = Base64Coder;
})(EndUser || (EndUser = {}));
var EndUser;
(function (EndUser) {
    ;
    var NetworkUtils = (function () {
        function NetworkUtils() {
        }
        NetworkUtils.parseURL = function (url) {
            var urlRegEx = new RegExp([
                '^(https?:)//',
                '(([^:/?#]*)(?::([0-9]+))?)',
                '(/{0,1}[^?]*)'
            ].join(''));
            var match = url.match(urlRegEx);
            return match && {
                protocol: match[1],
                host: match[2],
                hostname: match[3],
                port: match[4],
                pathname: match[5]
            };
        };
        return NetworkUtils;
    }());
    EndUser.NetworkUtils = NetworkUtils;
    ;
})(EndUser || (EndUser = {}));
var EndUser;
(function (EndUser) {
    var StringEncoding;
    (function (StringEncoding) {
        StringEncoding[StringEncoding["UTF_8"] = 'UTF-8'] = "UTF_8";
        StringEncoding[StringEncoding["UTF_16_LE"] = 'UTF-16LE'] = "UTF_16_LE";
        StringEncoding[StringEncoding["CP1251"] = 'windows-1251'] = "CP1251";
    })(StringEncoding = EndUser.StringEncoding || (EndUser.StringEncoding = {}));
    ;
    var StringCoder = (function () {
        function StringCoder() {
        }
        StringCoder.getCoder = function (encoding) {
            switch (encoding) {
                case StringEncoding.UTF_8:
                    return new UTF8StringCoder();
                case StringEncoding.UTF_16_LE:
                    return new UTF16LEStringCoder();
                case StringEncoding.CP1251:
                    return new CP1251StringCoder();
                default:
                    throw "Not supported";
            }
        };
        StringCoder.arrayToString = function (encoding, data) {
            if (encoding === void 0) { encoding = StringEncoding.UTF_8; }
            return StringCoder.getCoder(encoding).decode(data);
        };
        return StringCoder;
    }());
    EndUser.StringCoder = StringCoder;
    var UTF8StringCoder = (function () {
        function UTF8StringCoder() {
            this.decode = function (bytes) {
                var out = [], pos = 0, c = 0;
                while (pos < bytes.length) {
                    var c1 = bytes[pos++];
                    if (c1 < 128) {
                        out[c++] = String.fromCharCode(c1);
                    }
                    else if (c1 > 191 && c1 < 224) {
                        var c2 = bytes[pos++];
                        out[c++] = String.fromCharCode((c1 & 31) << 6 | c2 & 63);
                    }
                    else {
                        var c2 = bytes[pos++];
                        var c3 = bytes[pos++];
                        out[c++] = String.fromCharCode((c1 & 15) << 12 | (c2 & 63) << 6 | c3 & 63);
                    }
                }
                return out.join('');
            };
        }
        UTF8StringCoder.prototype.encode = function (str) {
            str = str.replace(/\r\n/g, '\n');
            var out = [], p = 0;
            for (var i = 0; i < str.length; i++) {
                var c = str.charCodeAt(i);
                if (c < 128) {
                    out[p++] = c;
                }
                else if (c < 2048) {
                    out[p++] = (c >> 6) | 192;
                    out[p++] = (c & 63) | 128;
                }
                else {
                    out[p++] = (c >> 12) | 224;
                    out[p++] = ((c >> 6) & 63) | 128;
                    out[p++] = (c & 63) | 128;
                }
            }
            return out;
        };
        return UTF8StringCoder;
    }());
    var UTF16LEStringCoder = (function () {
        function UTF16LEStringCoder() {
            this.decode = function (bytes) {
                var t1, t2;
                var i = 0;
                var ret = '';
                var length;
                if ((bytes.length % 2) != 0)
                    return null;
                length = bytes.length;
                if (length > 0 &&
                    bytes[length - 2] == 0 &&
                    bytes[length - 1] == 0) {
                    length -= 2;
                }
                while (i < length) {
                    ret += String.fromCharCode(bytes[i] | (bytes[i + 1] << 8));
                    i += 2;
                }
                return ret;
            };
        }
        UTF16LEStringCoder.prototype.encode = function (str) {
            str = str.replace(/\r\n/g, '\n');
            var out = [];
            var c;
            for (var i = 0; i < str.length; i++) {
                c = str.charCodeAt(i);
                out.push(c & 0xFF);
                out.push((c & 0xFF00) >> 8);
            }
            return out;
        };
        return UTF16LEStringCoder;
    }());
    var CP1251StringCoder = (function () {
        function CP1251StringCoder() {
            this.decode = function (bytes) {
                var t;
                var ret = '';
                for (var i = 0; i < bytes.length; i++) {
                    t = bytes[i];
                    if (t >= 0xC0 && t <= 0xFF)
                        ret += String.fromCharCode(t - 0xC0 + 0x0410);
                    else if (t >= 0x80 && t <= 0xBF)
                        ret += CP1251StringCoder.UTF8.charAt(t - 0x80);
                    else
                        ret += String.fromCharCode(t);
                }
                return ret;
            };
        }
        CP1251StringCoder.prototype.encode = function (str) {
            str = str.replace(/\r\n/g, '\n');
            var out = [];
            for (var i = 0; i < str.length; i++) {
                var ord = str.charCodeAt(i);
                if (!(ord in CP1251StringCoder.CP1251))
                    throw "Character " + str.charAt(i) + " isn't supported by win1251!";
                out.push(CP1251StringCoder.CP1251[ord]);
            }
            return out;
        };
        CP1251StringCoder.CP1251 = {
            0: 0, 1: 1, 2: 2, 3: 3, 4: 4,
            5: 5, 6: 6, 7: 7, 8: 8, 9: 9,
            10: 10, 11: 11, 12: 12, 13: 13, 14: 14,
            15: 15, 16: 16, 17: 17, 18: 18, 19: 19,
            20: 20, 21: 21, 22: 22, 23: 23, 24: 24,
            25: 25, 26: 26, 27: 27, 28: 28, 29: 29,
            30: 30, 31: 31, 32: 32, 33: 33, 34: 34,
            35: 35, 36: 36, 37: 37, 38: 38, 39: 39,
            40: 40, 41: 41, 42: 42, 43: 43, 44: 44,
            45: 45, 46: 46, 47: 47, 48: 48, 49: 49,
            50: 50, 51: 51, 52: 52, 53: 53, 54: 54,
            55: 55, 56: 56, 57: 57, 58: 58, 59: 59,
            60: 60, 61: 61, 62: 62, 63: 63, 64: 64,
            65: 65, 66: 66, 67: 67, 68: 68, 69: 69,
            70: 70, 71: 71, 72: 72, 73: 73, 74: 74,
            75: 75, 76: 76, 77: 77, 78: 78, 79: 79,
            80: 80, 81: 81, 82: 82, 83: 83, 84: 84,
            85: 85, 86: 86, 87: 87, 88: 88, 89: 89,
            90: 90, 91: 91, 92: 92, 93: 93, 94: 94,
            95: 95, 96: 96, 97: 97, 98: 98, 99: 99,
            100: 100, 101: 101, 102: 102, 103: 103, 104: 104,
            105: 105, 106: 106, 107: 107, 108: 108, 109: 109,
            110: 110, 111: 111, 112: 112, 113: 113, 114: 114,
            115: 115, 116: 116, 117: 117, 118: 118, 119: 119,
            120: 120, 121: 121, 122: 122, 123: 123, 124: 124,
            125: 125, 126: 126, 127: 127, 1027: 129, 8225: 135,
            1046: 198, 8222: 132, 1047: 199, 1168: 165, 1048: 200,
            1113: 154, 1049: 201, 1045: 197, 1050: 202, 1028: 170,
            160: 160, 1040: 192, 1051: 203, 164: 164, 166: 166, 167: 167,
            169: 169, 171: 171, 172: 172, 173: 173, 174: 174, 1053: 205,
            176: 176, 177: 177, 1114: 156, 181: 181, 182: 182, 183: 183,
            8221: 148, 187: 187, 1029: 189, 1056: 208, 1057: 209, 1058: 210,
            8364: 136, 1112: 188, 1115: 158, 1059: 211, 1060: 212, 1030: 178,
            1061: 213, 1062: 214, 1063: 215, 1116: 157, 1064: 216, 1065: 217,
            1031: 175, 1066: 218, 1067: 219, 1068: 220, 1069: 221, 1070: 222,
            1032: 163, 8226: 149, 1071: 223, 1072: 224, 8482: 153, 1073: 225,
            8240: 137, 1118: 162, 1074: 226, 1110: 179, 8230: 133, 1075: 227,
            1033: 138, 1076: 228, 1077: 229, 8211: 150, 1078: 230, 1119: 159,
            1079: 231, 1042: 194, 1080: 232, 1034: 140, 1025: 168, 1081: 233,
            1082: 234, 8212: 151, 1083: 235, 1169: 180, 1084: 236, 1052: 204,
            1085: 237, 1035: 142, 1086: 238, 1087: 239, 1088: 240, 1089: 241,
            1090: 242, 1036: 141, 1041: 193, 1091: 243, 1092: 244, 8224: 134,
            1093: 245, 8470: 185, 1094: 246, 1054: 206, 1095: 247, 1096: 248,
            8249: 139, 1097: 249, 1098: 250, 1044: 196, 1099: 251, 1111: 191,
            1055: 207, 1100: 252, 1038: 161, 8220: 147, 1101: 253, 8250: 155,
            1102: 254, 8216: 145, 1103: 255, 1043: 195, 1105: 184, 1039: 143,
            1026: 128, 1106: 144, 8218: 130, 1107: 131, 8217: 146, 1108: 186,
            1109: 190
        };
        CP1251StringCoder.UTF8 = unescape("%u0402%u0403%u201A%u0453%u201E%u2026%u2020%u2021%u20AC%u2030%u0409" +
            "%u2039%u040A%u040C%u040B%u040F%u0452%u2018%u2019%u201C%u201D%u2022" +
            "%u2013%u2014%u0000%u2122%u0459%u203A%u045A%u045C%u045B%u045F%u00A0" +
            "%u040E%u045E%u0408%u00A4%u0490%u00A6%u00A7%u0401%u00A9%u0404%u00AB" +
            "%u00AC%u00AD%u00AE%u0407%u00B0%u00B1%u0406%u0456%u0491%u00B5%u00B6" +
            "%u00B7%u0451%u2116%u0454%u00BB%u0458%u0405%u0455%u0457");
        return CP1251StringCoder;
    }());
})(EndUser || (EndUser = {}));
var WebExtension;
(function (WebExtension) {
    WebExtension.BROWSER_LAST_ERROR_MSG_PERMISSIONS = "Access to the specified native messaging host is forbidden.";
    WebExtension.BROWSER_LAST_ERROR_MSG_MISSING = "Specified native messaging host not found.";
    var BrowserStorage = (function () {
        function BrowserStorage() {
            if (BrowserRuntime.info.name == EndUser.BrowserName.Chrome) {
                this.m_storage = chrome.storage.sync ?
                    chrome.storage.sync : chrome.storage.local;
            }
            else {
                this.m_storage = chrome.storage.local;
            }
        }
        BrowserStorage.prototype.get = function (key, onSuccess, onError) {
            this.m_storage.get(key, function (items) {
                if (BrowserRuntime.lastError()) {
                    onError(BrowserRuntime.lastError().message);
                    return;
                }
                onSuccess(items);
            });
        };
        BrowserStorage.prototype.set = function (items, onSuccess, onError) {
            this.m_storage.set(items, function () {
                if (BrowserRuntime.lastError()) {
                    onError(BrowserRuntime.lastError().message);
                    return;
                }
                onSuccess();
            });
        };
        return BrowserStorage;
    }());
    WebExtension.BrowserStorage = BrowserStorage;
    var BrowserTab = (function () {
        function BrowserTab(tab) {
            this.m_tab = tab;
        }
        BrowserTab.prototype.getId = function () {
            return this.m_tab.id;
        };
        return BrowserTab;
    }());
    WebExtension.BrowserTab = BrowserTab;
    var MessageSender = (function () {
        function MessageSender(sender) {
            this.m_sender = sender;
            this.m_id = (BrowserRuntime.info.name ==
                EndUser.BrowserName.Firefox &&
                sender.extensionId) ?
                sender.extensionId : sender.id;
            this.m_tab = new BrowserTab(sender.tab);
        }
        MessageSender.prototype.getId = function () {
            return this.m_id;
        };
        MessageSender.prototype.getTab = function () {
            return this.m_tab;
        };
        return MessageSender;
    }());
    WebExtension.MessageSender = MessageSender;
    var ExtensionManifest = (function () {
        function ExtensionManifest(manifest) {
            this.m_manifest = manifest;
            this.m_name = manifest.name;
            this.m_version = manifest.version;
        }
        ExtensionManifest.prototype.getName = function () {
            return this.m_name;
        };
        ExtensionManifest.prototype.getVersion = function () {
            return this.m_version;
        };
        return ExtensionManifest;
    }());
    WebExtension.ExtensionManifest = ExtensionManifest;
    var BrowserRuntime = (function () {
        function BrowserRuntime() {
        }
        BrowserRuntime.addEventListener = function (type, callback) {
            switch (type) {
                case WebExtension.EVENT_LISTENER_TYPE_MESSAGE:
                    chrome.runtime.onMessage.addListener(callback);
                    break;
                default:
                    throw "Invalid listener type";
            }
        };
        BrowserRuntime.removeEventListener = function (callback) {
            chrome.runtime.onMessage.addListener(callback);
        };
        BrowserRuntime.i18n = function (id) {
            return chrome.i18n.getMessage(id);
        };
        BrowserRuntime.sendMessage = function (message) {
            chrome.runtime.sendMessage(message);
        };
        BrowserRuntime.getDefaultStorage = function () {
            return new BrowserStorage();
        };
        BrowserRuntime.lastError = function () {
            return chrome.runtime.lastError;
        };
        BrowserRuntime.onInstalledAddListener = function (callback) {
            if (!chrome.runtime.onInstalled ||
                !chrome.runtime.onInstalled.addListener) {
                return false;
            }
            chrome.runtime.onInstalled.addListener(callback);
            return true;
        };
        BrowserRuntime.onTabsRemovedAddListener = function (callback) {
            if (!chrome.tabs.onRemoved ||
                !chrome.tabs.onRemoved.addListener) {
                return false;
            }
            chrome.tabs.onRemoved.addListener(callback);
            return true;
        };
        BrowserRuntime.connectNative = function (id) {
            return chrome.runtime.connectNative(id);
        };
        BrowserRuntime.sendNativeMessage = function (id, message, callback) {
            chrome.runtime.sendNativeMessage(id, message, callback);
        };
        BrowserRuntime.getRuntimeId = function () {
            return chrome.runtime.id;
        };
        BrowserRuntime.tabsSendMessage = function (tab, message) {
            chrome.tabs.sendMessage(tab.getId(), message);
        };
        BrowserRuntime.tabsCreate = function (tab) {
            chrome.tabs.create(tab);
        };
        BrowserRuntime.browserActionSetIcon = function (iconSet) {
            chrome.browserAction.setIcon({ path: iconSet });
        };
        BrowserRuntime.getBackgroundPage = function (callback) {
            chrome.runtime.getBackgroundPage(callback);
        };
        ;
        BrowserRuntime.getManifest = function () {
            return new ExtensionManifest(chrome.runtime.getManifest());
        };
        BrowserRuntime.info = EndUser.Browser.info;
        return BrowserRuntime;
    }());
    WebExtension.BrowserRuntime = BrowserRuntime;
})(WebExtension || (WebExtension = {}));
var WebExtension;
(function (WebExtension) {
    WebExtension.EVENT_LISTENER_TYPE_MESSAGE = 'message';
    WebExtension.EVENT_ON_INSTALLED_INSTALL = 'install';
    WebExtension.EVENT_ON_INSTALLED_UPDATE = 'update';
    WebExtension.EVENT_ON_INSTALLED_CHROME_UPDATE = 'chrome_update';
    WebExtension.EVENT_ON_INSTALLED_SHARED_MODULE_UPDATE = 'shared_module_update';
    WebExtension.NMH_MESSAGE_HEADER_SIZE = 4;
    WebExtension.NMH_MESSAGE_HEADER_PART = 'part';
    WebExtension.NMH_MESSAGE_HEADER_LAST = 'last';
    WebExtension.NMH_SERVICE_MESSAGE_SIZE = 4;
    WebExtension.NMH_SERVICE_MESSAGE_RESET = 'rset';
    WebExtension.NMH_SERVICE_MESSAGE_NEXT = 'next';
    WebExtension.NMH_SERVICE_MESSAGE_INFO = 'info';
    WebExtension.NMH_SERVICE_MESSAGE_ERROR_BAD_PARAMETER = 'err0';
    WebExtension.NMH_SERVICE_MESSAGE_ERROR_MEMORY_ALLOCATION = 'err1';
    WebExtension.WEB_EXTENSION_REQUEST_VERSION_1 = 1;
    WebExtension.WEB_EXTENSION_REQUEST_VERSION = 2;
    WebExtension.WEB_EXTENSION_RESPONSE_VERSION_1 = 1;
    WebExtension.WEB_EXTENSION_RESPONSE_VERSION = 2;
    WebExtension.WEB_EXTENSION_SETTINGS_VERSION = 1;
    WebExtension.WEB_EXTENSION_ERROR_NONE = 0;
    WebExtension.WEB_EXTENSION_ERROR_NATIVE_APP_NOT_INSTALLED = 1;
    WebExtension.WEB_EXTENSION_ERROR_UNTRUSTED_URL = 2;
    WebExtension.WEB_EXTENSION_ERROR_UNKNOWN = 0xFFFF;
    WebExtension.SETTINGS_PAGE_URI = "/views/settings/settings.html";
    var WebExtensionStatus;
    (function (WebExtensionStatus) {
        WebExtensionStatus[WebExtensionStatus["UNKNOWN"] = 0] = "UNKNOWN";
        WebExtensionStatus[WebExtensionStatus["NOT_INSTALLED"] = 1] = "NOT_INSTALLED";
        WebExtensionStatus[WebExtensionStatus["INSTALLED"] = 2] = "INSTALLED";
        WebExtensionStatus[WebExtensionStatus["FORBIDDEN"] = 3] = "FORBIDDEN";
    })(WebExtensionStatus = WebExtension.WebExtensionStatus || (WebExtension.WebExtensionStatus = {}));
    ;
    var NativeAppType;
    (function (NativeAppType) {
        NativeAppType[NativeAppType["UNKNOWN"] = 0] = "UNKNOWN";
        NativeAppType[NativeAppType["NPAPI"] = 1] = "NPAPI";
        NativeAppType[NativeAppType["NMH"] = 2] = "NMH";
    })(NativeAppType = WebExtension.NativeAppType || (WebExtension.NativeAppType = {}));
    ;
    var Strings = (function () {
        function Strings() {
        }
        Strings.APP_COMPLEX = 'app_complex';
        Strings.APP_COMPLEX_FULL_NAME = 'app_complex_full_name';
        Strings.APP_NAME = 'app_name';
        Strings.APP_DESCRIPTION = 'app_description';
        Strings.APP_AUTHOR = 'app_author';
        Strings.APP_NAME_TITLE = 'app_name_title';
        Strings.APP_VERSION_TITLE = 'app_version_title';
        Strings.APP_AUTHOR_TITLE = 'app_author_title';
        Strings.NATIVE_APP_STATUS_TITLE_NMH = 'native_app_status_title_nmh';
        Strings.NATIVE_APP_STATUS_TITLE_NPAPI = 'native_app_status_title_npapi';
        Strings.NATIVE_APP_STATUS_INSTALLED = 'native_app_status_installed';
        Strings.NATIVE_APP_STATUS_NOT_INSTALLED = 'native_app_status_not_installed';
        Strings.NATIVE_APP_STATUS_FORBIDDEN = 'native_app_status_start_forbidden';
        Strings.NATIVE_APP_STATUS_UNKNOWN = 'native_app_status_unknown';
        Strings.NATIVE_APP_STATUS_VERSION_NOT_SUPPORTED = 'native_app_status_version_not_supported';
        Strings.NATIVE_APP_VERSION_TITLE_NMH = 'native_app_version_title_nmh';
        Strings.NATIVE_APP_VERSION_TITLE_NPAPI = 'native_app_version_npapi';
        Strings.NATIVE_APP_DOWNLOAD_AND_INSTALL = 'native_app_download_and_install';
        Strings.VIEW_TITLE_SETTINGS = 'view_title_settings';
        Strings.MENU_ITEM_CHECK_UPDATE = 'menu_item_check_update';
        Strings.MENU_ITEM_SETTINGS = 'menu_item_settings';
        Strings.MENU_ITEM_HELP = 'menu_item_help';
        Strings.MENU_ITEM_INFORMATION = 'menu_item_information';
        Strings.LABEL_HELP = 'label_help';
        Strings.LABEL_SETTINGS = 'label_settings';
        Strings.LABEL_INFORMATION = 'label_information';
        Strings.LABEL_WEB_EXTENSION = 'label_web_extension';
        Strings.LABEL_ABOUT_LIBRARY = 'label_about_library';
        Strings.LABEL_TRUSTED_WEB_SITES = 'label_trusted_web_sites';
        Strings.BUTTON_ADD = 'button_add';
        Strings.BUTTON_DELETE = 'button_delete';
        Strings.BUTTON_SAVE = 'button_save';
        Strings.ALERT_MSG_OPEN_HELP_PAGE = 'alert_msg_open_help_page';
        Strings.ALERT_MSG_INVALID_URL = 'alert_msg_invalid_url';
        Strings.ALERT_MSG_URL_IN_LIST = 'alert_msg_url_in_list';
        Strings.ALERT_MSG_TRUSTED_SITES_SAVE_SUCCESS = 'alert_msg_trusted_sites_save_success';
        Strings.ALERT_MSG_TRUSTED_SITES_SAVE_ERROR = 'alert_msg_trusted_sites_save_error';
        Strings.ALERT_MSG_ALLOW_WEB_SITE_ACCESS = 'alert_msg_allow_web_site_access';
        return Strings;
    }());
    WebExtension.Strings = Strings;
    ;
    ;
    var Images = (function () {
        function Images() {
        }
        Images.TAB_BAR_ICON_DEFAULT = {
            '16': 'icons/TabBar.16.png',
            '32': 'icons/TabBar.32.png',
            '64': 'icons/TabBar.64.png',
            '128': 'icons/TabBar.128.png'
        };
        Images.TAB_BAR_ICON_WARNING = {
            '16': 'icons/TabBarWarning.16.png',
            '32': 'icons/TabBarWarning.32.png',
            '64': 'icons/TabBarWarning.64.png',
            '128': 'icons/TabBarWarning.128.png'
        };
        Images.TAB_BAR_ICON_ERROR = {
            '16': 'icons/TabBarError.16.png',
            '32': 'icons/TabBarError.32.png',
            '64': 'icons/TabBarError.64.png',
            '128': 'icons/TabBarError.128.png'
        };
        return Images;
    }());
    WebExtension.Images = Images;
    ;
})(WebExtension || (WebExtension = {}));
var WebExtension;
(function (WebExtension_1) {
    var WebExtension = (function () {
        function WebExtension(id, nativeAppName, info) {
            this.sendResponse = function (data, callback_id, error, url, senderTab) {
                try {
                    var response = WebExtension_1.Connector.createResponse();
                    response.sender = this.m_id;
                    response.data = data;
                    response.callback_id = callback_id;
                    response.error = error;
                    response.url = url;
                    WebExtension_1.BrowserRuntime.tabsSendMessage(senderTab, response);
                }
                catch (e) {
                }
            };
            this.m_id = id;
            this.m_status = WebExtension_1.WebExtensionStatus.UNKNOWN;
            this.m_nativeApp = new WebExtension_1.NativeAppNMH(nativeAppName, this);
            this.m_settings = new WebExtension_1.Settings(WebExtension_1.WEB_EXTENSION_SETTINGS_VERSION);
            this.m_info = info;
        }
        WebExtension.prototype._onInstalled = function (details) {
        };
        WebExtension.prototype._onTabsRemoved = function (tabId) {
            var pThis = this;
            pThis.m_nativeApp.handleTabRemoved(tabId);
        };
        WebExtension.prototype._onHandleMessage = function (requestData, sender, callback) {
            var pThis = this;
            if (sender.getId() !== WebExtension_1.BrowserRuntime.getRuntimeId())
                return;
            var request = WebExtension_1.Connector.initRequestWithEventData(requestData, null);
            if (request == null)
                return;
            var url = EndUser.NetworkUtils.parseURL(request.url);
            if (!url)
                return;
            var urlString = url.protocol + "//" + url.hostname;
            if (!pThis.m_settings.isSiteTrusted(urlString)) {
                if (request.urlAddToTrusted) {
                    pThis.m_settings.addTrustedSite(urlString, function () {
                        pThis._onHandleMessage(requestData, sender, callback);
                    }, function (error) {
                        pThis.sendResponse(null, request.callback_id, WebExtension_1.WEB_EXTENSION_ERROR_UNKNOWN, request.url, sender.getTab());
                    });
                    return;
                }
                pThis.sendResponse(null, request.callback_id, WebExtension_1.WEB_EXTENSION_ERROR_UNTRUSTED_URL, request.url, sender.getTab());
                return;
            }
            pThis.m_nativeApp.handleMessage(request, sender.getTab());
        };
        WebExtension.prototype.initialize = function (onSuccess, onError) {
            var pThis = this;
            WebExtension_1.BrowserRuntime.onInstalledAddListener(function (details) {
                pThis._onInstalled(details);
            });
            WebExtension_1.BrowserRuntime.addEventListener(WebExtension_1.EVENT_LISTENER_TYPE_MESSAGE, function (request, sender, callback) {
                pThis._onHandleMessage(request, new WebExtension_1.MessageSender(sender), callback);
            });
            WebExtension_1.BrowserRuntime.onTabsRemovedAddListener(function (tabId, removeInfo) {
                pThis._onTabsRemoved(tabId);
            });
            pThis.m_settings.read(function () {
                pThis.m_nativeApp.initialize(function (status) {
                    pThis.m_status = status;
                    onSuccess();
                });
            }, function (error) {
                onError(error);
            });
        };
        WebExtension.prototype.finalize = function (onSuccess, onError) {
            var pThis = this;
            setTimeout(function () {
                onSuccess();
            }, 1);
        };
        WebExtension.prototype.getNativeAppStatus = function () {
            return this.m_status;
        };
        WebExtension.prototype.getNativeAppStatusString = function () {
            var status = '';
            switch (this.m_status) {
                case WebExtension_1.WebExtensionStatus.INSTALLED:
                    status = WebExtension_1.Strings.NATIVE_APP_STATUS_INSTALLED;
                    break;
                case WebExtension_1.WebExtensionStatus.NOT_INSTALLED:
                    status = WebExtension_1.Strings.NATIVE_APP_STATUS_NOT_INSTALLED;
                    break;
                case WebExtension_1.WebExtensionStatus.FORBIDDEN:
                    status = WebExtension_1.Strings.NATIVE_APP_STATUS_FORBIDDEN;
                    break;
                case WebExtension_1.WebExtensionStatus.UNKNOWN:
                default:
                    status = WebExtension_1.Strings.NATIVE_APP_STATUS_UNKNOWN;
                    break;
            }
            return WebExtension_1.BrowserRuntime.i18n(status);
        };
        WebExtension.prototype.getNativeAppType = function () {
            if (this.m_nativeApp == null)
                WebExtension_1.NativeAppType.UNKNOWN;
            return this.m_nativeApp.getType();
        };
        WebExtension.prototype.getNativeAppVersion = function () {
            if (this.m_nativeApp == null || this.m_nativeApp.getInfo() == null)
                return '';
            return this.m_nativeApp.getInfo().version;
        };
        WebExtension.prototype.getInstallURLs = function () {
            var installs = null;
            switch (EndUser.Browser.info.osName) {
                case EndUser.OSName.Windows:
                    installs = [this.m_info.installs.windows];
                    break;
                case EndUser.OSName.Mac:
                    installs = [this.m_info.installs.macos];
                    break;
                case EndUser.OSName.Linux:
                    installs = EndUser.Browser.info.arch == EndUser.BrowserArch.x86 ?
                        this.m_info.installs.linux.x32 : this.m_info.installs.linux.x64;
                    break;
                default:
                    return [];
            }
            var urls = [];
            for (var i = 0; i < installs.length; i++) {
                urls.push(this.m_info.downloadURL + installs[i]);
            }
            return urls;
        };
        WebExtension.prototype.getHelpURL = function () {
            return this.m_info.downloadURL + this.m_info.help;
        };
        WebExtension.prototype.getTrustedSites = function () {
            return this.m_settings.getTrustedSites();
        };
        WebExtension.prototype.setTrustedSites = function (sites, onSuccess, onError) {
            this.m_settings.setTrustedSites(sites, onSuccess, onError);
        };
        return WebExtension;
    }());
    WebExtension_1.WebExtension = WebExtension;
})(WebExtension || (WebExtension = {}));
var WebExtension;
(function (WebExtension) {
    ;
    var NMHConnection = (function () {
        function NMHConnection(nmhName, id, url, senderTab, delegate) {
            this._handleNextRequest = function () {
                var pThis = this;
                if (!pThis._hasRequests())
                    return;
                var request = pThis.m_requests.shift();
                if (!pThis.send(request.id, request.data)) {
                    pThis.m_delegate.onConnectionError(pThis, request.id);
                    setTimeout(function () {
                        pThis._handleNextRequest();
                    }, 1);
                    return;
                }
            };
            this.m_nmhName = nmhName;
            this.m_id = id;
            this.m_url = url;
            this.m_senderTab = senderTab;
            this.m_delegate = delegate;
            this.m_port = null;
            this.m_activeRequest = null;
            this.m_requests = new Array();
        }
        NMHConnection.prototype._appendPart = function (data) {
            var pThis = this;
            var request = pThis.m_activeRequest;
            var newPart = new Uint8Array(request.part.length + data.length);
            newPart.set(request.part);
            newPart.set(data, request.part.length);
            request.part = newPart;
        };
        NMHConnection.prototype._hasRequests = function () {
            return this.m_requests.length > 0;
        };
        NMHConnection.prototype.getId = function () {
            return this.m_id;
        };
        NMHConnection.prototype.getURL = function () {
            return this.m_url;
        };
        NMHConnection.prototype.getSenderTab = function () {
            return this.m_senderTab;
        };
        NMHConnection.prototype.connect = function () {
            var pThis = this;
            if (pThis.m_port)
                return true;
            try {
                pThis.m_port = WebExtension.BrowserRuntime.connectNative(pThis.m_nmhName);
                pThis.m_port.onDisconnect.addListener(function () {
                    pThis.disconnect();
                });
                pThis.m_port.onMessage.addListener(function (data) {
                    pThis.recieve(data);
                });
                return true;
            }
            catch (e) {
                pThis.m_port = null;
                return false;
            }
        };
        NMHConnection.prototype.disconnect = function () {
            var pThis = this;
            if (pThis._hasRequests()) {
                pThis.m_requests.forEach(function (request) {
                    pThis.m_delegate.onConnectionError(pThis, request.id);
                });
                pThis.m_requests = new Array();
            }
            if (pThis.m_activeRequest != null) {
                pThis.m_delegate.onConnectionError(pThis, pThis.m_activeRequest.id);
                pThis.m_activeRequest = null;
            }
            pThis.m_delegate.onConnectionDisconnect(pThis);
            try {
                pThis.m_port.disconnect();
            }
            catch (e) {
            }
            pThis.m_port = null;
        };
        NMHConnection.prototype.send = function (id, data) {
            var pThis = this;
            var request = {
                id: id,
                data: data,
                part: new Uint8Array(0)
            };
            if (pThis.m_activeRequest != null) {
                pThis.m_requests.push(request);
                return true;
            }
            try {
                pThis.m_port.postMessage(JSON.parse(data));
                pThis.m_activeRequest = request;
            }
            catch (e) {
                return false;
            }
            return true;
        };
        ;
        NMHConnection.prototype.recieve = function (data) {
            var pThis = this;
            if (pThis.m_activeRequest == null)
                return;
            if (!data) {
                pThis.m_delegate.onConnectionError(pThis, pThis.m_activeRequest.id);
                pThis.m_activeRequest = null;
                pThis._handleNextRequest();
                return;
            }
            try {
                var header = data.slice(0, WebExtension.NMH_MESSAGE_HEADER_SIZE);
                var body = data.slice(WebExtension.NMH_MESSAGE_HEADER_SIZE);
                if (body != null || body != '') {
                    pThis._appendPart(EndUser.Base64Coder.decode(body));
                }
                switch (header) {
                    case WebExtension.NMH_MESSAGE_HEADER_PART:
                        pThis.m_port.postMessage(new Object(WebExtension.NMH_SERVICE_MESSAGE_NEXT));
                        break;
                    case WebExtension.NMH_MESSAGE_HEADER_LAST:
                        var response = EndUser.StringCoder.arrayToString(EndUser.StringEncoding.UTF_8, pThis.m_activeRequest.part);
                        pThis.m_delegate.onConnectionRecieveData(pThis, pThis.m_activeRequest.id, response);
                        pThis.m_activeRequest = null;
                        pThis._handleNextRequest();
                        break;
                    case WebExtension.NMH_SERVICE_MESSAGE_ERROR_BAD_PARAMETER:
                    case WebExtension.NMH_SERVICE_MESSAGE_ERROR_MEMORY_ALLOCATION:
                    default:
                        pThis.m_delegate.onConnectionError(pThis, pThis.m_activeRequest.id);
                        pThis.m_activeRequest = null;
                        pThis._handleNextRequest();
                        break;
                }
            }
            catch (e) {
                pThis.m_delegate.onConnectionError(pThis, pThis.m_activeRequest.id);
                pThis.m_activeRequest = null;
                pThis._handleNextRequest();
            }
        };
        return NMHConnection;
    }());
    ;
    var NativeAppNMH = (function () {
        function NativeAppNMH(name, delegate) {
            this.m_name = name;
            this.m_delegate = delegate;
            this.m_info = null;
            this.m_connections = new Array();
        }
        NativeAppNMH.prototype.initialize = function (onResult) {
            var pThis = this;
            WebExtension.BrowserRuntime.sendNativeMessage(pThis.m_name, new Object(WebExtension.NMH_SERVICE_MESSAGE_INFO), function (response) {
                var status = WebExtension.WebExtensionStatus.NOT_INSTALLED;
                var iconsSet = WebExtension.Images.TAB_BAR_ICON_DEFAULT;
                if (!response) {
                    var errorMsg = WebExtension.BrowserRuntime.lastError().message;
                    if (errorMsg == WebExtension.BROWSER_LAST_ERROR_MSG_PERMISSIONS) {
                        status = WebExtension.WebExtensionStatus.FORBIDDEN;
                    }
                    else if (errorMsg == WebExtension.BROWSER_LAST_ERROR_MSG_MISSING) {
                        status = WebExtension.WebExtensionStatus.NOT_INSTALLED;
                    }
                    else {
                        status = WebExtension.WebExtensionStatus.NOT_INSTALLED;
                    }
                }
                else {
                    if (!response.version) {
                        status = WebExtension.WebExtensionStatus.NOT_INSTALLED;
                    }
                    else {
                        pThis.m_info = response;
                        status = WebExtension.WebExtensionStatus.INSTALLED;
                    }
                }
                switch (status) {
                    case WebExtension.WebExtensionStatus.INSTALLED:
                        iconsSet = WebExtension.Images.TAB_BAR_ICON_DEFAULT;
                        break;
                    case WebExtension.WebExtensionStatus.FORBIDDEN:
                        iconsSet = WebExtension.Images.TAB_BAR_ICON_WARNING;
                        break;
                    case WebExtension.WebExtensionStatus.NOT_INSTALLED:
                    default:
                        iconsSet = WebExtension.Images.TAB_BAR_ICON_ERROR;
                        break;
                }
                WebExtension.BrowserRuntime.browserActionSetIcon(iconsSet);
                onResult(status);
            });
        };
        NativeAppNMH.prototype.getType = function () {
            return WebExtension.NativeAppType.NMH;
        };
        NativeAppNMH.prototype.getInfo = function () {
            return this.m_info;
        };
        NativeAppNMH.prototype.handleMessage = function (request, senderTab) {
            var pThis = this;
            var connection;
            var connection_id = senderTab.getId();
            var url = request.url;
            if (!pThis.m_connections[connection_id]) {
                connection = new NMHConnection(pThis.m_name, connection_id, url, senderTab, pThis);
                if (!connection.connect()) {
                    pThis.m_delegate.sendResponse(null, request.callback_id, WebExtension.WEB_EXTENSION_ERROR_UNKNOWN, connection.getURL(), connection.getSenderTab());
                    return;
                }
                pThis.m_connections[connection_id] = connection;
            }
            else {
                connection = pThis.m_connections[connection_id];
            }
            if (!connection.send(request.callback_id, request.request)) {
                pThis.m_delegate.sendResponse(null, request.callback_id, WebExtension.WEB_EXTENSION_ERROR_UNKNOWN, connection.getURL(), connection.getSenderTab());
                return;
            }
        };
        NativeAppNMH.prototype.handleTabRemoved = function (tabId) {
            var pThis = this;
            var connection_id = tabId;
            if (!pThis.m_connections[connection_id])
                return;
            pThis.m_connections[connection_id].disconnect();
        };
        NativeAppNMH.prototype.onConnectionRecieveData = function (connection, requestId, data) {
            var pThis = this;
            var connectionId = connection.getId();
            if (!pThis.m_connections[connectionId])
                return;
            pThis.m_delegate.sendResponse(data, requestId, WebExtension.WEB_EXTENSION_ERROR_NONE, connection.getURL(), connection.getSenderTab());
        };
        NativeAppNMH.prototype.onConnectionError = function (connection, requestId) {
            var pThis = this;
            var connectionId = connection.getId();
            if (!pThis.m_connections[connectionId])
                return;
            pThis.m_delegate.sendResponse(null, requestId, WebExtension.WEB_EXTENSION_ERROR_UNKNOWN, connection.getURL(), connection.getSenderTab());
        };
        NativeAppNMH.prototype.onConnectionDisconnect = function (connection) {
            var pThis = this;
            var connectionId = connection.getId();
            if (!pThis.m_connections[connectionId])
                return;
            delete pThis.m_connections[connectionId];
        };
        return NativeAppNMH;
    }());
    WebExtension.NativeAppNMH = NativeAppNMH;
})(WebExtension || (WebExtension = {}));
var WebExtension;
(function (WebExtension) {
    var Settings = (function () {
        function Settings(version) {
            this.m_storage = WebExtension.BrowserRuntime.getDefaultStorage();
            this.m_settings = {
                version: version,
                trustedSites: new Array()
            };
        }
        Settings.prototype._read = function (onSuccess, onError) {
            var pThis = this;
            pThis.m_storage.get(pThis.m_settings, function (settings) {
                if (pThis.m_settings.version >= settings.version) {
                    pThis.m_settings.trustedSites = settings.trustedSites;
                    onSuccess();
                }
                else {
                    pThis.m_settings.trustedSites = settings.trustedSites;
                    pThis._write(onSuccess, onError);
                }
            }, onError);
        };
        Settings.prototype._write = function (onSuccess, onError) {
            var pThis = this;
            pThis.m_storage.set(pThis.m_settings, onSuccess, onError);
        };
        Settings.prototype.read = function (onSuccess, onError) {
            this._read(onSuccess, onError);
        };
        Settings.prototype.save = function (onSuccess, onError) {
            this._write(onSuccess, onError);
        };
        Settings.prototype.isSiteTrusted = function (uri) {
            return this.m_settings.trustedSites.indexOf(uri) >= 0;
        };
        Settings.prototype.addTrustedSite = function (uri, onSuccess, onError) {
            this.m_settings.trustedSites.push(uri);
            this._write(onSuccess, onError);
        };
        Settings.prototype.getTrustedSites = function () {
            return this.m_settings.trustedSites.slice();
        };
        Settings.prototype.setTrustedSites = function (sites, onSuccess, onError) {
            this.m_settings.trustedSites = sites;
            this._write(onSuccess, onError);
        };
        return Settings;
    }());
    WebExtension.Settings = Settings;
})(WebExtension || (WebExtension = {}));
var WebExtension;
(function (WebExtension) {
    ;
    ;
    var Connector = (function () {
        function Connector() {
        }
        Connector.cloneObject = function (object) {
            var objectCopy = new Object();
            Object.keys(object).forEach(function (key) {
                if (typeof object[key] === "object")
                    objectCopy[key] = Connector.cloneObject(object[key]);
                else
                    objectCopy[key] = object[key];
            });
            return objectCopy;
        };
        Connector.createRequest = function () {
            var request = {
                version: WebExtension.WEB_EXTENSION_REQUEST_VERSION,
                sender: null,
                request: null,
                callback_id: -1,
                url: null,
                urlAddToTrusted: false
            };
            return request;
        };
        Connector.initRequestWithEventData = function (eventData, url) {
            if (url === void 0) { url = null; }
            if (!eventData)
                return null;
            var request = Connector.createRequest();
            var data = eventData;
            request.version = (data.version) ?
                data.version : WebExtension.WEB_EXTENSION_REQUEST_VERSION_1;
            if (request.version < WebExtension.WEB_EXTENSION_REQUEST_VERSION_1)
                return null;
            if (!data.sender || !data.request || !data.callback_id)
                return null;
            if ((url == null) && (!data.url ||
                (typeof data.urlAddToTrusted != 'boolean'))) {
                return null;
            }
            request.sender = data.sender;
            request.request = data.request;
            request.callback_id = data.callback_id;
            request.url = (url != null) ? url : data.url;
            request.urlAddToTrusted = (url != null) ?
                false : data.urlAddToTrusted;
            return request;
        };
        Connector.cloneRequest = function (request) {
            return Connector.cloneObject(request);
        };
        Connector.createResponse = function () {
            var response = {
                version: WebExtension.WEB_EXTENSION_RESPONSE_VERSION,
                sender: null,
                data: null,
                callback_id: -1,
                error: null,
                url: null
            };
            return response;
        };
        Connector.initResponseWithEventData = function (eventData) {
            if (!eventData)
                return null;
            var response = Connector.createResponse();
            var data = eventData;
            response.version = (data.version) ?
                data.version : WebExtension.WEB_EXTENSION_RESPONSE_VERSION_1;
            if (response.version < WebExtension.WEB_EXTENSION_RESPONSE_VERSION_1)
                return null;
            if (!data.sender || !data.callback_id)
                return null;
            if ((typeof data.error != 'number') || !data.url)
                return null;
            response.sender = data.sender;
            response.data = data.data;
            response.callback_id = data.callback_id;
            response.error = data.error;
            response.url = data.url;
            return response;
        };
        Connector.cloneResponse = function (response) {
            return Connector.cloneObject(response);
        };
        return Connector;
    }());
    WebExtension.Connector = Connector;
    ;
})(WebExtension || (WebExtension = {}));
var EUSWExtension;
(function (EUSWExtension) {
    EUSWExtension.EUSWE_DOWNLOADS_PAGE = 'https://iit.com.ua/download/productfiles/';
    EUSWExtension.EUSWE_INSTALL_WIN = 'EUSignWebInstall.exe';
    EUSWExtension.EUSWE_INSTALL_MAC = 'EUSignWebInstall.pkg';
    EUSWExtension.EUSWE_INSTALL_LINUX_X32 = 'euswi.deb';
    EUSWExtension.EUSWE_INSTALL_LINUX_X64 = 'euswi.64.deb';
    EUSWExtension.EUSWE_INSTALL_LINUX_RPM_X32 = 'euswi.rpm';
    EUSWExtension.EUSWE_INSTALL_LINUX_RPM_X64 = 'euswi.64.rpm';
    EUSWExtension.EUSWE_INSTALL_LINUX_TAR_X32 = 'euswi.tar';
    EUSWExtension.EUSWE_INSTALL_LINUX_TAR_X64 = 'euswi.64.tar';
    EUSWExtension.EUSWE_MANUAL = 'EUSignWebOManual.pdf';
    EUSWExtension.EUSWE_LISTENER_SENDER_ID = "JSONRPCClient";
    EUSWExtension.EUSWE_EXTENSION_NAME_CHROME = "chrome-extension://jffafkigfgmjafhpkoibhfefeaebmccg/";
    EUSWExtension.EUSWE_EXTENSION_NAME_FIREFOX = "eusw@iit.com.ua";
    EUSWExtension.EUSWE_NMH_NAME = "ua.com.iit.eusign.nmh";
})(EUSWExtension || (EUSWExtension = {}));
var WebExtension;
(function (WebExtension) {
    var ContentPage = (function () {
        function ContentPage(senderId, extensionId) {
            this.m_senderId = senderId;
            this.m_extensionId = extensionId;
            this.m_isTrustedSite = false;
            this.m_requests = new Array();
            var pThis = this;
            this.m_onWindowMessage = function (event) {
                pThis._onWindowMessage(event);
            };
            this.m_onBrowserRuntimeMessage = function (message) {
                pThis._onBrowserRuntimeMessage(message);
            };
        }
        ContentPage.prototype._onWindowMessage = function (event) {
            if (!event || !event.data || !event.origin)
                return;
            if ((event.source != window) ||
                (event.data.sender != this.m_senderId)) {
                return;
            }
            var request;
            request = WebExtension.Connector.initRequestWithEventData(event.data, event.origin);
            if (request == null)
                return;
            this._sendWebExtensionRequest(request);
        };
        ContentPage.prototype._onBrowserRuntimeMessage = function (message) {
            var pThis = this;
            var response = WebExtension.Connector.initResponseWithEventData(message);
            if (response == null)
                return;
            if (response.sender != pThis.m_extensionId)
                return;
            var request = pThis.m_requests[response.callback_id - 1];
            if (!request)
                return;
            delete pThis.m_requests[response.callback_id - 1];
            if (response.error == WebExtension.WEB_EXTENSION_ERROR_UNTRUSTED_URL) {
                var msg = WebExtension.BrowserRuntime.i18n(WebExtension.Strings.ALERT_MSG_ALLOW_WEB_SITE_ACCESS);
                msg = msg.replace("%s", request.url);
                if (confirm(msg)) {
                    request.urlAddToTrusted = true;
                    pThis._sendWebExtensionRequest(request);
                    return;
                }
            }
            response.callback_id = request.callback_id;
            window.postMessage(response, "*");
        };
        ContentPage.prototype._sendWebExtensionRequest = function (request) {
            var callback_id = this.m_requests.push(request);
            request = WebExtension.Connector.cloneRequest(request);
            request.callback_id = callback_id;
            WebExtension.BrowserRuntime.sendMessage(request);
        };
        ContentPage.prototype.addEventListeners = function () {
            var pThis = this;
            window.addEventListener(WebExtension.EVENT_LISTENER_TYPE_MESSAGE, this.m_onWindowMessage);
            WebExtension.BrowserRuntime.addEventListener(WebExtension.EVENT_LISTENER_TYPE_MESSAGE, this.m_onBrowserRuntimeMessage);
        };
        ContentPage.prototype.removeEventListeners = function () {
            var pThis = this;
            window.removeEventListener(WebExtension.EVENT_LISTENER_TYPE_MESSAGE, this.m_onWindowMessage);
            WebExtension.BrowserRuntime.removeEventListener(this.m_onBrowserRuntimeMessage);
        };
        ContentPage.prototype.initialize = function (onSuccess, onError) {
            var pThis = this;
            pThis.addEventListeners();
            setTimeout(function () {
                onSuccess();
            }, 1);
        };
        ContentPage.prototype.finalize = function (onSuccess, onError) {
            var pThis = this;
            pThis.removeEventListeners();
            setTimeout(function () {
                onSuccess();
            }, 1);
        };
        ContentPage.prototype.getExtensionId = function () {
            return this.m_extensionId;
        };
        return ContentPage;
    }());
    WebExtension.ContentPage = ContentPage;
    ;
})(WebExtension || (WebExtension = {}));
var WebExtension;
(function (WebExtension) {
    var Translator = (function () {
        function Translator() {
        }
        Translator.translateString = function (id, defaultValue) {
            var msg = WebExtension.BrowserRuntime.i18n(id);
            if (msg && msg != '')
                return msg;
            return defaultValue;
        };
        Translator.translateElement = function (element) {
            element.innerHTML = Translator.translateString(element.getAttribute(Translator.TRANSLATOR_ATTRIBUTE), element.innerHTML);
        };
        Translator.translateAllElements = function (document) {
            var items = document.getElementsByClassName(Translator.TRANSLATOR_ATTRIBUTE);
            for (var i = 0; i < items.length; i++)
                Translator.translateElement(items[i]);
        };
        Translator.TRANSLATOR_ATTRIBUTE = "i18n";
        return Translator;
    }());
    WebExtension.Translator = Translator;
})(WebExtension || (WebExtension = {}));
